<template>
  <div>
    <!-- Cuerpo -->
    <div class="padding-top">
      <el-header height="110px" style="margin: 0 12rem;">

        <ReturnButton v-on:clickEvent="verifyEditModal" :isValidate="true" :offsetArrow="20" :spanTitle="3"  title="Ir a Programas" class="text-end"></ReturnButton> 
      
       <!-- Modal del boton de regresar  -->
        <AppModal :show-dialog.sync="returnButtonModal"  v-if="returnButtonModal" nameClass="dialog-red" :rutImg="require(`../../assets/images/alerta.svg`)" sizeImg="80%" textBold="¿Estás seguro?" 
          :parrafo="'Si sales del formulario, la información se perderá.' "
          classBtn1="border-red" typeBtn1="danger" btn1="Salir" btn2="Seguir aquí" v-on:btnEvent="returnButtonModal = false"  @btnEvent="viewListPrograms" v-on:eventBtn="returnButtonModal = false">
        </AppModal>

        <el-col :span="24" style="padding-top: 1.5rem">
          <el-card :body-style="{ padding: '10px' }" shadow="never" class="bg-form text-white title-views">Nuevo Programa</el-card>
        </el-col>
      </el-header>
      <el-main style="margin: 3rem 12.5rem">
        <el-form :rules="rules" ref="formProgram" :model="formProgram">

          <!-- titulo -->
          <!--  v-if="userName!='' && userName.toUpperCase()=='MMANSI'" -->
          <template>
            <h4 class="text-orange" style="margin-bottom:2rem"> TÍTULO ABREVIADO DEL PROGRAMA </h4>
            <el-row type="flex" align="middle">
              <el-col :span="18" :offset="3" >
                <!-- <el-form-item label="Título:" prop="programTitle" class="inputTitle"> -->
                  <el-input class="inputTitle" v-model="formProgram.programTitle" size="small"></el-input>
                <!-- </el-form-item> -->
              </el-col>
            </el-row>
            <hr style="margin:2.5rem 0">
          </template>

          <!-- Título para Geminis -->            
          <h4 class="text-orange" style="margin-bottom:2rem">TÍTULO PARA PAUTEO </h4>
          <el-row type="flex" align="middle">
            <el-col :span="23" :offset="1">
              <el-form-item label="Título:" prop="programTitleGeminis" class="inputTitle">
                <el-input :disabled="isDisabledEdit"  v-model="formProgram.programTitleGeminis" type="text" size="small" show-word-limit maxlength="40" ></el-input>
              </el-form-item>
            </el-col>
          </el-row>
          
          <hr style="margin:2.5rem 0">
          <h4 class="text-orange" style="margin-bottom:2rem">CARACTERÍSTICAS DEL PROGRAMA</h4>
          <el-row type="flex" align="middle">
            <el-col :span="24" :offset="1">
              <el-form-item label="Tipo de Contenido:" prop="typeOfContent" class="inputTitleLarge">
                <el-autocomplete placeholder="Seleccionar" :disabled="isDisabledEdit"
                  v-model="formProgram.typeOfContent"
                  style="width: 100%;"
                  size="small"
                  :fetch-suggestions="querySearchNameCostCenter"
                  :trigger-on-focus="true"
                  @select="handleSelectCostCenter"
                  >
                  <template slot-scope="props">
                    <div>{{ props.item.label }}</div>
                  </template>
                </el-autocomplete>
              </el-form-item>
            </el-col>
          </el-row>
          <hr style="margin-top:2.5rem">

          <!-- <hr style="margin:2.5rem 0"> -->
          <h4 class="text-orange" style="margin-bottom:2rem; margin-top:2.5rem">PRECIO POR DÍA</h4>
          <el-row type="flex" align="middle">
              <el-col :span="6" :offset="3">
                <!-- <el-form-item label="Precio por día:" class="selectInput"> -->
                  <el-input class="inputTitle" v-model="formProgram.priceForDay" size="small" type="number"></el-input>
                <!-- </el-form-item> -->
              </el-col>
            </el-row>
          <hr style="margin-top:2.5rem">

          <!-- vigencia -->
          <h4 class="text-orange" style="margin: 3rem 0 2rem">VIGENCIA</h4>
          <el-row type="flex" align="middle">
            <!-- INICIO DE VIGENCIA  -->
            <el-col :span="11" :offset="1">
              <el-form-item prop="validity[0].startValidity" label="Inicio:" class="selectInput">
                <el-date-picker :disabled="isDisabledEdit"
                  v-model="formProgram.validity[0].startValidity" type="date" placeholder="Seleccionar"
                  format="MM/dd/yyyy" size="small" @input="validateEndDate"> 
                </el-date-picker>      
              </el-form-item>
            </el-col>
            <!-- FIN DE VIGENCIA -->
            <el-col :span="11" :offset="1">
              <el-form-item prop="validity[0].endValidity" label="Fin:" class="selectInput">
                <el-date-picker :disabled="isDisabledEdit"
                  v-model="formProgram.validity[0].endValidity" type="date" placeholder="Seleccionar"
                  format="MM/dd/yyyy" size="small" :picker-options="datePickerOptions"> 
                </el-date-picker>     
              </el-form-item>
            </el-col>
          </el-row>
          <hr style="margin-top:2.5rem">

          <!-- HORARIO DEL PROGRAMA -->
          <h4 class="text-orange" style="margin: 3rem 0 2rem">HORARIO DEL PROGRAMA</h4>
          <el-row style="margin-bottom:3rem">
            <el-col :span="11" :offset="1">
              <el-row type="flex" align="middle">
                <el-col :span="6">
                  <span class="font-general">Inicio:</span>
                </el-col>
                <el-col :span="9">
                  <el-form-item prop="scheduleStartHour" class="inputTitle">
                    <el-input :disabled="isDisabledEdit" size="small" v-model="formProgram.scheduleStartHour" placeholder="00" v-on:keypress.native="isNumber" ref="jump4" @keyup.enter.native="$refs.jump1.focus" maxlength="2">
                      <template slot="append">hr</template>
                    </el-input>
                  </el-form-item>
                </el-col>
                <el-col :span="9">
                  <el-form-item prop="scheduleStartMin" class="inputTitle">
                    <el-input :disabled="isDisabledEdit" size="small" v-model="formProgram.scheduleStartMin" placeholder="00" v-on:keypress.native="isNumber" ref="jump1" @keyup.enter.native="$refs.jump2.focus" maxlength="2">
                      <template slot="append">min</template>
                    </el-input>
                  </el-form-item>
                </el-col>
              </el-row>
            </el-col>

            <el-col :span="11" :offset="1">
              <el-row type="flex" align="middle">
                <el-col :span="6">
                  <span class="font-general">Fin:</span>
                </el-col>
                <el-col :span="9">
                  <el-form-item prop="scheduleEndHour" class="inputTitle">
                    <el-input :disabled="isDisabledEdit" size="small" v-model="formProgram.scheduleEndHour" placeholder="00" v-on:keypress.native="isNumber" ref="jump2" @keyup.enter.native="$refs.jump3.focus" maxlength="2">
                      <template slot="append">hr</template>
                    </el-input>
                  </el-form-item>
                </el-col>
                <el-col :span="9">
                  <el-form-item prop="scheduleEndMin" class="inputTitle">
                    <el-input :disabled="isDisabledEdit" size="small" v-model="formProgram.scheduleEndMin" placeholder="00" v-on:keypress.native="isNumber" ref="jump3" @keyup.enter.native="$refs.jump4.focus" maxlength="2">
                      <template slot="append">min</template>
                    </el-input>
                  </el-form-item>
                </el-col> 
              </el-row>
            </el-col>
          </el-row>
          <hr style="margin-top:2.5rem">

          <!-- DIAS DE TRANSMISION -->
          <h4 class="text-orange" style="margin: 3rem 0 2rem">DÍAS DE TRANSMISIÓN</h4>
          <el-row type="flex" align="middle">
            <el-col :span="23" :offset="1">
              <el-form-item prop="transmissionDays">
                <el-radio-group v-model="transmission" @change="weeksChange" style="margin-bottom:1.6rem">
                  <el-radio :disabled="isDisabledEdit" :label="3" style="margin-right: 2rem">Todos los días</el-radio>
                  <el-radio :disabled="isDisabledEdit" :label="6" style="margin-right: 2rem">Lunes a Viernes</el-radio>
                  <el-radio :disabled="isDisabledEdit" :label="9" style="margin-right: 2rem">Sábados y Domingos</el-radio>
                </el-radio-group>
                <el-checkbox-group  v-model="formProgram.transmissionDays" @change="handleCheckedDaysChange">
                  <el-checkbox-button v-for="day in days" :label="day" :key="day" :disabled="isDisabledEdit">{{day}}</el-checkbox-button>
                </el-checkbox-group>
              </el-form-item>
            </el-col>
          </el-row>
          <hr style="margin-top:2.5rem">

          <!-- Sección de Canal de transmisión -->
          <h4 class="text-orange" style="margin: 3rem 0 2rem">CANAL DE TRANSMISIÓN</h4>
          <el-row style="margin-bottom: 1rem">
            <el-col :span="6" :offset="1">     
              <!--  @change="validCheckChanels" -->
              <el-checkbox-group v-model="formProgram.checkedChanels" :disabled="isDisabledEdit">
                <el-checkbox v-for="channel in channels" :label="channel" :key="channel" style="display: block; margin:1rem 0 2rem 0;">
                  <div>{{channel}}</div>
                </el-checkbox>
              </el-checkbox-group>
            </el-col>
          </el-row>

          <!-- SEÑALES -->
          <div v-show="channelSelected">
            <h4 class="text-orange" style="margin: 3rem 0 2rem">SEÑALES</h4>
            <el-row style="margin: 0.7rem 0 1rem">          
              <el-col :span="6">
                <el-checkbox :disabled="isDisabledEdit" :indeterminate="isIndeterminate" v-model="checkAll" @change="handleCheckAllChange" border>Todas las señales</el-checkbox>
              </el-col>
              <el-col :span="6"><el-button @click="signalModal = true">Seleccionar</el-button></el-col>
              <!-- Modal -->
              <el-dialog
                :visible.sync="signalModal"
                width="40%"
                center
                :close-on-press-escape="false"
                custom-class="dialog-orange">
                <!--  prop="checkedSignals" -->
                <el-form-item style="margin: 0">
                  <el-checkbox-group v-model="formProgram.checkedSignals" @change="handleCheckedSignalsChange" class="text-center" style="margin-left: 3rem;">
                    <el-checkbox  v-for="signal in signals" :label="signal" :key="signal" style="width: 30%; margin: 0" class="text-start" :disabled="isDisabledEdit">{{signal}}</el-checkbox>
                  </el-checkbox-group>              
                </el-form-item>
                <div style="text-align: right; margin-top: 20px">
                  <el-button @click="signalModal = false" class="text-orange border-orange">CANCELAR</el-button>
                  <el-button @click="signalModal = false" type="primary">ACEPTAR</el-button>
                </div>
              </el-dialog>
            </el-row>
            <el-form-item style="margin: 0 0 4rem" >
              <div class="bg-gray">
                <div style="display: table; height: 3.5rem; padding: 10px 7px 7px">
                  <el-col v-for="(item, j) in formProgram.checkedSignals" :key="j" 
                    class="bg-white" style="margin:7px; padding:0 5px;width:8rem">{{item}} </el-col>
                </div>
              </div>
            </el-form-item>
          </div>
          <!-- Botón cancelar e ingresar -->
          <div class="text-end">
            <el-button v-on:click="modalCancelButton = true" class="text-orange border-orange">CANCELAR</el-button>
            <!-- <el-button @click="checkCrosses" type="primary">INGRESAR</el-button>  -->
            <el-button v-if="newOrEditProgram == 'newProgram'" @click="submitForm('formProgram')" type="primary">INGRESAR</el-button> 
            <el-button v-else @click="submitForm('formProgram')" type="primary" :disabled="isBtnDisabled">ACTUALIZAR</el-button>

          </div>        
          <!-- Modal botón cancelar -->
          <AppModalDanger :show-dialog.sync="modalCancelButton" v-if="modalCancelButton" v-on:btnEvent="modalCancelButton = false"  @btnEvent="viewListPrograms" v-on:eventBtn="modalCancelButton = false" >
          </AppModalDanger>
          <!-- Modal botón ingresar-->
          <AppModalSuccess 
            :show-dialog.sync="addProgramModal" 
            widthModal="35%"  
            v-if="addProgramModal"
            :styleModal="true"
            :show="false"
            :parrafo="'El programa ' + formProgram.programTitle + ' se ha agregado a la lista. <br> Su código es <strong>'+ this.nuevocodigoProgram +'</strong> . '"
            btn1="Ver programas " 
            btn2="Nuevo programa" 
            v-on:btnEvent="addProgramModal = false"  
            @btnEvent="viewListPrograms" 
            v-on:eventBtn="addProgramModal = false" 
            @eventBtn="cleanAllInputs('formProgram')" >
          </AppModalSuccess>
          <!-- Modal checkCrosses -->
          <!-- <el-dialog
            :visible.sync="checkCrossesModal"
            width="35%"
            :close-on-press-escape="false"
            :show-close="false"
            custom-class="dialog-orange">
            <el-row>
              <el-col :span="5">
                <img src="../../assets/images/pensante.svg" alt="emoticon" width="80%">
              </el-col>
              <el-col :span="18" :offset="1">
                <p class="subtitle-styles line-height: 22px">¡Espera!</p>
                <p style="line-height: 22px">Este programa ocupará:</p>
                <p style="line-height: 22px"
                  v-for="(item, index) in arrCheckCrosses"
                  :key="index">
                  <span>{{item.time}} de <strong>"{{item.title}}"</strong></span>
                </p>
                <div class="text-end" style="margin-top: 3rem">
                  <el-button @click="checkCrossesModal = false" v-on:click="cleanArrcheckCrosses" class="border-orange text-orange" plain>CANCELAR</el-button>
                  <el-button @click="checkCrossesModal = false" v-on:click="getGridAndPatchMaterials" type="primary">ACEPTAR</el-button>              
                </div>
              </el-col>
            </el-row>
          </el-dialog> -->

          <!-- MODAL DE FORMULARIO INVALIDO -->
          <AppModal :show-dialog.sync="invalidForm" v-if="invalidForm" nameClass="dialog-red" 
            :rutImg="require(`../../assets/images/alerta.svg`)" sizeImg="80%"  
            :parrafo="'Por favor, ingrese todos los campos requeridos.'">
          </AppModal>

          <!-- MODAL DE LOS SECUENCES DESFAZADOS  -->
          <el-dialog
            :visible.sync="isModalSecuences"
            width="35%"
            center
            :show-close="false"
            custom-class="dialog-red">
            <el-row>
              <el-col :span="6"><img src="../../assets/images/alerta.svg" width="70%" alt="emoticon"></el-col>
              <el-col :span="18">
                <!-- <p style="margin-bottom: 0.5rem"><strong> ERROR !!</strong></p> -->
                <p style="line-height: 22px;">Los códigos generados por la plataforma Géminis no <span class="text-red text-bold"> COINCIDEN </span> . </p> <br>
                <p style="line-height: 22px;">Comunicarse con el área de  <strong> DESARROLLO - BACK OFFICE </strong>.</p>
              </el-col>
            </el-row>
          </el-dialog>
        </el-form>
      </el-main>
    </div>
  </div>
</template>

<script>
// IMPORTAR COMPONENTES
import AppModal from '@/components/AppModal.vue'
import AppModalDanger from '@/components/AppModalDanger.vue'
import AppModalSuccess from '@/components/AppModalSuccess.vue'
import ReturnButton from '@/components/ReturnButton.vue'
// IMPORTAR DESDE MAIN.JS
import { HTTP } from '@/main.js'
// IMPORTAR DESDE UTILS.JS
import { formatDateString, getFirstDay, restTimes, validateTime } from '@/utils/calculateTime.js'
import { modifyText } from '@/utils/modifyText.js'

//let months = ['Enero', 'Febrero', 'Marzo', 'Abril', 'Mayo', 'Junio', 'Julio', 'Agosto', 'Septiembre', 'Octubre', 'Noviembre', 'Diciembre'];
const allWeek = ["Lunes", "Martes", "Miércoles", "Jueves", "Viernes", "Sábado", "Domingo"];
const week = ["Lunes", "Martes", "Miércoles", "Jueves", "Viernes"];
// const numberWeek = [2, 3, 4, 5, 6, 7, 1]
const weekend = ["Sábado", "Domingo"];

// String.prototype.toProperCase = function () {
//   const re = /(^|[^A-Za-zÁÉÍÓÚÜÑáéíóúüñ])(?:([a-záéíóúüñ])|([A-ZÁÉÍÓÚÜÑ]))|([A-ZÁÉÍÓÚÜÑ]+)/gu;
//   return this.replace(re,
//     (m, caracterPrevio, minuscInicial, mayuscInicial, mayuscIntermedias) => {
//         const locale = ['es', 'gl', 'ca', 'pt', 'en'];
//         if (mayuscIntermedias)
//             return mayuscIntermedias.toLocaleLowerCase(locale);
//         return caracterPrevio
//               + (minuscInicial ? minuscInicial.toLocaleUpperCase(locale) : mayuscInicial);
//     });
// };

Array.prototype.containsArray = function (array) {
  if (arguments[1]) {
    var index = arguments[1], last = arguments[2];
  } else {
    var index = 0, last = 0; this.sort(); array.sort();
  };
  
  return index == array.length
      || ( last = this.indexOf( array[index], last ) ) > -1
      && this.containsArray( array, ++index, ++last );                      
};

export default {
  components: {
    ReturnButton,
    AppModal,
    AppModalSuccess,
    AppModalDanger
  },
  data () {
    return {
      signalsTable: [], //Desde DB - Señales
      arrSignalsCode: [],
      codigoDias: [],
      numberWeek: [2, 3, 4, 5, 6, 7, 1],
      codeGeminis: 0,
      formProgram: {
        priceForDay: '',
        programTitle: "",
        programTitleGeminis: "",
        transmissionDays: [],
        transmissionDaysDescription: "",
        checkedSignals: [],
        checkedSignalsDescription: '',
        scheduleStartHour:"",
        scheduleStartMin:"",
        scheduleEndHour:"",
        scheduleEndMin:"",
        validity: [
          { startValidity: '',
            endValidity: ''}
        ],
        typeOfContent: "",
        checkedChanels: ['América TV']
      },
      rules: {
        typeOfContent: [
          { required: true, message: 'Por favor ingrese este campo', trigger: 'change' },
        ],
        programTitle: [
          { required: true, message: 'Por favor ingrese este campo', trigger: 'change' },
        ],
        programTitleGeminis: [
          { required: true, message: 'Por favor ingrese este campo', trigger: 'change'}
        ],
        validity: [
          { 
            startValidity: [{ required: true, message: 'Por favor seleccione un valor', trigger: 'change' }],
            endValidity: [{ required: true, message: 'Por favor seleccione un valor', trigger: 'change' }]
          }
        ],
        scheduleStartHour: [
          { required: true, message: 'Ingrese este campo', trigger: 'change' },
        ],
        scheduleStartMin: [
          { required: true, message: 'Ingrese este campo', trigger: 'change' },
        ],
        scheduleEndHour: [
          { required: true, message: 'Ingrese este campo', trigger: 'change' },
        ],
        scheduleEndMin: [
          { required: true, message: 'Ingrese este campo', trigger: 'change' },
        ],
        transmissionDays: [
          { required: true, message: 'Por favor seleccione los días de transmisión', trigger: 'change' },
        ],
        // checkedSignals: [
        //   { required: true, message: 'Por favor seleccione las señales', trigger: 'change' },
        // ]
      },
      transmission: [],
      days: allWeek,
      laboralDays: week,
      weekend: weekend,
      isIndeterminate: false,
      checkAll: true,
      signalModal: false,
      addProgramModal: false,
      // checkCrossesModal: false,
      returnButtonModal: false,
      modalCancelButton: false,
      datePickerOptions: {
        disabledDate: this.disabledValidityDate
      },
      arrCheckCrosses: [],
      crushedPrograms: [],
      userName: '',
      userEmail: localStorage.getItem('userEmail'),
      code:'',
      programasArr: [],
      contador: 0,
      flagComputed:-2,
      ultimoCodigoDeProgram: '',
      ultimoCodigoDeGeminis: '',
      nuevoCodigoGeminis: '',
      nuevocodigoProgram: '',
      signals: '',
      invalidForm: '',
      optionsTypeOfContent: [
        {
          value: 'AG',
          label: 'Agrícolas'
        },
           {
          value: 'BE',
          label: 'Concursos de belleza'
        },
           {
          value: 'CN',
          label: 'Concurso'
        },
           {
          value: 'CO',
          label: 'Cómicos'
        },
           {
          value: 'DE',
          label: 'Deportivos'
        },
          {
          value: 'DF',
          label: 'Documental'
        },
          {
          value: 'DG',
          label: 'Tv digital'
        },
         {
          value: 'DM',
          label: 'Desfile militar'
        },
         {
          value: 'ELE',
          label: 'Electorales'
        },
         {
          value: 'EN',
          label: 'Entrevistas'
        },
         {
          value: 'ENT',
          label: 'Entretenimiento'
        },
         {
          value: 'ES',
          label: 'Especiales'
        },
         {
          value: 'FC',
          label: 'Cocina'
        },
        {
          value: 'FE',
          label: 'Ferias'
        },
         {
          value: 'FM',
          label: 'Femeninos'
        },
         {
          value: 'HI',
          label: 'Himno nacional'
        },
        {
          value: 'ID',
          label: 'Dibujos'
        },
         {
          value: 'IP',
          label: 'Infantiles (Programas)'
        },
         {
          value: 'ME',
          label: 'Musical y entrevista'
        },
         {
          value: 'MG',
          label: 'Magazine'
        },
        {
          value: 'MIC',
          label: 'Micro programas'
        },

        {
          value: 'MS',
          label: 'Miniseries'
        },
         {
          value: 'MU',
          label: 'Musicales'
        },
         {
          value: 'NA',
          label: 'Ninguna anterior'
        },
        {
          value: 'NO',
          label: 'Noticieros'
        },
            {
          value: 'PA',
          label: 'Largometraje'
        },
         {
          value: 'PE',
          label: 'Periodísticos'
        },
         {
          value: 'PO',
          label: 'Políticos'
        },
        {
          value: 'PTEC',
          label: 'Programa tecnológicos'
        },
           {
          value: 'RE',
          label: 'Religiosos'
        },
           {
          value: 'RV',
          label: 'Revistas'
        },
           {
          value: 'SA',
          label: 'Series'
        },
           {
          value: 'SAL',
          label: 'Salud'
        },
           {
          value: 'TEL',
          label: 'Teleserie'
        },
        {
          value: 'TN',
          label: 'Telenovelas'
        },
        {
          value: 'TS',
          label: 'Talk show'
        },

      ],
      codeTypeContent: '',
      channels: ['América TV', 'América Next'],
      firstDayOfWeek: '',
      startDate: '',
      firstDay: '',
      secondDay: '',
      thirdDay: '',
      fourthDay: '',
      fifthDay: '',
      sixthDay: '',
      lastDay: '',
      endDate: '',
      startDate: '',
      firstDay: '',
      month: '',
      month2: '',
      year: '',
      year2: '',
      dateString: '',
      newOrEditProgram: JSON.parse(sessionStorage.getItem('newOrEditProgram')),
      boleanSecuences: null,
      isModalSecuences: false,
      channelSelected: true,
      isBtnDisabled: true,
      isEditUserMmansi: null
    };
  },  
  computed: {
    visorTime() {
      const elem = [
        this.formProgram.scheduleStartHour,
        this.formProgram.scheduleStartMin,
        this.formProgram.scheduleEndHour,
        this.formProgram.scheduleEndMin
      ].join()
      return elem
    },
    isDisabledEdit() {
      if(this.newOrEditProgram == 'editProgram' && this.userName == 'MMANSI') {
        let conditional = this.isEditUserMmansi == this.userName ? false : true
        return conditional
      } else {
        return false
      }
    },
    // isSignalNecesaryReturn() {
    //   if(this.isSignalNecesary == false) {
    //     return [{required: false, message: 'Por favor seleccione las señales', trigger: 'change' }]
    //   } else {
    //     return [{required: true, message: 'Por favor seleccione las señales', trigger: 'change' }]
    //   }
      
      // return this.isSignalNecesary
    // },
    verifyChangeModal () {
      this.flagComputed++;
      const array = [
       this.formProgram.programTitleGeminis,
       this.formProgram.transmissionDays.length,
       this.formProgram.transmissionDaysDescription,
       this.formProgram.checkedSignals.length,
       this.formProgram.checkedSignalsDescription,
       this.formProgram.scheduleStartHour,
       this.formProgram.scheduleStartMin,
       this.formProgram.scheduleEndHour,
       this.formProgram.scheduleEndMin, 
       this.formProgram.validity ? this.formProgram.validity[0].endValidity : [] ,
       this.formProgram.validity ? this.formProgram.validity[0].startValidity  : []
      ].join()
      return array
    },
    visorMultipleItems() {
      const data = [
        this.formProgram.checkedChanels,
        this.formProgram.checkedSignals,
        this.arrSignalsCode
      ].join()
      return data
    },
    // btnIsDisabled () {
    //   if(this.channelSelected !== '' && this.channelSelected == 'América Next') {
    //     return true
    //   }else {
    //     return false
    //   }
    // }
  },
  created () {
    if(this.newOrEditProgram == 'editProgram') {
      this.fetchProgram() 
    }
    else {
      this.arrSignalsCode = [
        "AR",
        "CY",
        "CH",
        "DG",
        "HU",
        "LI",
        "PI",
        "PC",
        "T1",
        "T2",
        "TC",
        "TR",
        "WE",
        "PN",
        "CU",
        "IC",
        "TP",
        "IQ",
        "TB",
        "CJ",
        "DI",
        "CN",
        "TE"
      ]
      this.formProgram.checkedSignals = [
        "Arequipa",
        "Chiclayo",
        "Chimbote",
        "Digital",
        "Huancayo",
        "Lima",
        "Piura",
        "Pucallpa",
        "T1",
        "T2",
        "Tacna",
        "Trujillo",
        "Web",
        "Puno",
        "Cusco",
        "Ica",
        "Tarapoto",
        "Iquitos",
        "Tumbes",
        "Cajamarca",
        "Discovery Channel",
        "Canal N",
        "Televisa"
      ]
    }
    this.getTables ()
    this.getSignals()
    this.gettingUsername()
    console.log(this.userName);
  },
  methods: {
    querySearchNameCostCenter (queryString, cb) {
      let links = this.optionsTypeOfContent
      let results = links.filter(link=>modifyText(link.label).toUpperCase().includes(modifyText(queryString).toUpperCase()))
      cb(results);
      this.typeOfContentAutocomplete = results
    },
    handleSelectCostCenter (item) {
      this.formProgram.typeOfContent = item.label
      this.codeTypeContent = item.value
    },
    // getAllPrograms() {
    //   this.$store.dispatch('getData', "programs/allprograms/allprograms")
    // },
    gettingUsername() { 
      let user = this.userEmail.split('@')[0]
      this.userName = user.toUpperCase()
    },
    fetchProgram () {
      const programId = JSON.parse(this.$localStorage.get('programId'));
      HTTP.get(`programs/`+ programId)
        .then(res => {
          console.log(res.data.program, 'res')
          this.formProgram = res.data.program; 
          this.formProgram.programTitleGeminis  =  res.data.program.programTitleGeminis == '' ||  res.data.program.programTitleGeminis == undefined   ?  res.data.program.programTitle : res.data.program.programTitleGeminis
          this.codeTypeContent = res.data.program.codeTypeContent
          // DATE OF START VALIDITY
          let startValidity = this.formProgram.validity[0].startValidity.split("/")
          let newStartValidity = startValidity[1]+'/'+startValidity[0]+'/'+startValidity[2]
          this.formProgram.validity[0].startValidity = new Date(newStartValidity).getTime()
          // DATE OF END VALIDITY
          let endValidity = this.formProgram.validity[0].endValidity.split("/")
          let newEndValidity = endValidity[1]+'/'+endValidity[0]+'/'+endValidity[2]
          this.formProgram.validity[0].endValidity = new Date(newEndValidity).getTime()
          this.codigoDias = res.data.program.codeDays
          this.arrSignalsCode = res.data.program.signalsCode
          this.handleCheckedDaysChange(this.formProgram.transmissionDays)
          this.isEditUserMmansi = this.formProgram.userNameAlta
      })
      .catch(err => console.log(err))
    },
    getTables () {
      let dataType = 'tables'
      this.$store.dispatch("getData", dataType)
    },
    getSignals () {
      HTTP.get('tables/tableName/allSignals')
      .then(res => {
        this.signals = res.data.table[0].types
        this.signalsTable = res.data.table[0].types
        this.signalsByCode = res.data.table[0].description
      })
      .catch(err => {
        console.log(err)
      }); 
    },
    verifyEditModal () {
      if(this.contador > 0) {
        this.returnButtonModal = true
      }
      else {
        this.$router.push({name: 'programs'})
      }
    },
    // getProgramas () {     
    //   HTTP.get('programs')
    //     .then(res => {
    //       this.programasArr = res.data.programs;  
    //       this.ultimoCodigoDeProgram = (res.data.programs[0].codProgram)?res.data.programs[0].codProgram:60002
    //       this.ultimoCodigoDeGeminis = res.data.programs[0].geminisCode
    //     })
    //     .catch(err => {
    //       console.log(err);
    //     });
      
    // },
    getTables () {
      let dataType = 'tables';
      this.$store.dispatch("getData", dataType);
    },
    disabledValidityDate (time) {
      return time.getTime() < this. formProgram.validity[0].startValidity
    },
    validateEndDate () {
      if (this.formProgram.validity[0].startValidity > this.formProgram.validity[0].endValidity) {
          this.formProgram.validity[0].endValidity = this.formProgram.validity[0].startValidity
      }
    },
    isNumber (evt) {
      evt = (evt) ? evt : window.event;
      var charCode = (evt.which) ? evt.which : evt.keyCode;
      if ((charCode > 31 && (charCode < 48 || charCode > 57)) && charCode !== 46) {
        evt.preventDefault();
      } else {
        return true;
      }      
    },
    weeksChange (val) {
      let arrCode = []
      let arrIndexCode;
      if (this.transmission === 3) {
        this.formProgram.transmissionDays = val ? allWeek : [];
        console.log(val);  
       arrIndexCode = this.arrayDiasCode(allWeek)
   
      } else if (this.transmission === 6) {
        this.formProgram.transmissionDays = val ? week : [];
        arrIndexCode = this.arrayDiasCode(week)
      } else if (this.transmission === 9) {
        this.formProgram.transmissionDays = val ? weekend : [];
        arrIndexCode = this.arrayDiasCode(weekend)
      }

      for(var r=0; r<arrIndexCode.length; r++){
        arrCode.push(this.numberWeek[arrIndexCode[r]])
      }
      this.codigoDias = arrCode
      console.log(this.codigoDias, "this.codigoDias")
    
    },
    handleCheckedDaysChange (value) {
      
      if (value.length === 7) {
        this.transmission = 3
      } else if (value.sort().join() == weekend.sort().join()) {
        this.transmission = 9
      } else  if (value.sort().join() == week.sort().join()) {
        this.transmission = 6
      } else {
        this.transmission = []
      }

      let arrCode = []
      let arrIndexCode = this.arrayDiasCode(value)
      for(var r=0; r<arrIndexCode.length; r++){
        arrCode.push(this.numberWeek[arrIndexCode[r]])
      }
      this.codigoDias = arrCode
      console.log(this.codigoDias, "this.codigoDias")

    },
    submitForm(formName) {
      this.$refs[formName].validate((valid) => {
        console.log(valid, 'valid')
        if (valid) {
          let haveSelectSignals = this.formProgram.checkedSignals
          // if(haveSelectSignals.length > 0) {
            if(this.contador==-1) this.onSubmitProgramMongo();
            else this.onSubmitProgram()
          // } else {
          //   this.invalidForm = true
          //   return false;
          // }
          // this.obteniendoProgramasQueCoincidenConLasHoras()
        } else {
          this.invalidForm = true
          return false;
        }
      });
    },
    sliceGridDaysCrushed(allPrograms, id ) {
      this.arrCheckCrosses.map((el, i, arr) => {
        for (let index = 0; index < el.completeDaysCrushed.length; index++) {
          allPrograms.map((ella, indice, arr) => {
            if(el.completeDaysCrushed[index] == ella.completeDate && el.time == 'Todo el horario' && el.title == ella.programGridTitle ) {
              allPrograms.splice(indice, 1)
            }
            else if (el.completeDaysCrushed[index] == ella.completeDate && el.title == ella.programGridTitle && el.time !== 'Todo el horario' ) {
              ella.scheduleStartHour = el.crossingTimes.scheduleStartHour
              ella.scheduleStartMin = el.crossingTimes.scheduleStartMin
              ella.scheduleEndHour = el.crossingTimes.scheduleEndHour
              ella.scheduleEndMin = el.crossingTimes.scheduleEndMin
            } 
        })  
        }    
      }) 
    
      HTTP.patch('grid/' + id,
      [{
        propName: "programs", value: allPrograms
      }])
      .then(res => {
      })
      .catch(err => console.log(err));
      this.onSubmitProgram()
    },
    convertHourDate (date, hours, minutes) {
      var d = new Date(date).toLocaleDateString('en-GB')
      var newString = d + ' ' + hours + ':' + minutes + ':' + '00'
      return newString 
    },
    obteniendoLaPrimeraFechaDelMes  (date, hours, min) {
      
      var d = new Date(date).toLocaleDateString('en-GB')
      let newArrDate = d.split('/')
      console.log(newArrDate, 'newArrDate')
      let fecha = '01/' + newArrDate[1] + '/' + newArrDate[2]  + ' ' + hours + ':' +  min + ':00'
      return fecha
    },
    async onSubmitProgram () {
      // Días de transmisión
      let transmissionDaysToFilter = this.formProgram.transmissionDays;
      let missingDays = this.days.filter(function(obj) { return transmissionDaysToFilter.indexOf(obj) == -1; });
      let daysLeftover = this.days.filter(function(obj) { return missingDays.indexOf(obj) == -1; });
      this.formProgram.transmissionDays = daysLeftover;

      // Horario
      if (this.formProgram.scheduleStartHour.length === 1) {
        this.formProgram.scheduleStartHour = "0" + this.formProgram.scheduleStartHour;
      }
      if (this.formProgram.scheduleStartMin.length === 1) {
        this.formProgram.scheduleStartMin = "0" + this.formProgram.scheduleStartMin;
      }
      if (this.formProgram.scheduleEndHour.length === 1) {
        this.formProgram.scheduleEndHour = "0" + this.formProgram.scheduleEndHour;
      }
      if (this.formProgram.scheduleEndMin.length === 1) {
        this.formProgram.scheduleEndMin = "0" + this.formProgram.scheduleEndMin;
      }

      // Días de transmisión
      if (this.formProgram.transmissionDays.join() == this.laboralDays.join()) {
        this.formProgram.transmissionDaysDescription = 'De Lunes a Viernes'
      }

      if (this.formProgram.transmissionDays.join() != this.laboralDays.join() && this.formProgram.transmissionDays.length !== 7) {
        let description = this.formProgram.transmissionDays.join(', ');
        this.formProgram.transmissionDaysDescription = description.replace(/,(?=[^,]*$)/, ' y');
      }

      if (this.formProgram.transmissionDays.join() == this.weekend.join()) {
        this.formProgram.transmissionDaysDescription = 'Sábados y domingos'
      }

      if (this.formProgram.transmissionDays.length === 7) {
        this.formProgram.transmissionDaysDescription = 'Todos los días'
      }

      let hoursInicio = this.convertHourDate(this.formProgram.validity[0].startValidity, this.formProgram.scheduleStartHour, this.formProgram.scheduleStartMin)
      let hoursFin = this.convertHourDate(this.formProgram.validity[0].endValidity, this.formProgram.scheduleEndHour, this.formProgram.scheduleEndMin)
      let hoursStartFirstDayInMonth = this.obteniendoLaPrimeraFechaDelMes(this.formProgram.validity[0].startValidity, this.formProgram.scheduleStartHour, this.formProgram.scheduleStartMin)
      let hoursEndFirstDayInMonth = this.obteniendoLaPrimeraFechaDelMes(this.formProgram.validity[0].startValidity, this.formProgram.scheduleEndHour, this.formProgram.scheduleEndMin)
      
      //Generar Código
      if(this.newOrEditProgram == 'newProgram') {
        let newProgram = {
          codProgram: null,
          programTitle: this.userName !== 'MMANSI' ? this.formProgram.programTitleGeminis.trim() : this.formProgram.programTitle.trim() ,
          programTitleGeminis: this.formProgram.programTitleGeminis.trim(),
          transmissionDays: this.formProgram.transmissionDays,
          transmissionDaysDescription: this.formProgram.transmissionDaysDescription,
          checkedSignals:this.formProgram.checkedSignals,
          checkedSignalsDescription: (this.formProgram.checkedSignals).join(', '),
          scheduleStartHour: this.formProgram.scheduleStartHour,
          scheduleStartMin:this.formProgram.scheduleStartMin,
          scheduleEndHour:this.formProgram.scheduleEndHour,
          scheduleEndMin:this.formProgram.scheduleEndMin,
          validity: [{
            startValidity:this.formProgram.validity[0].startValidity.toLocaleDateString('en-GB'),
            endValidity:this.formProgram.validity[0].endValidity.toLocaleDateString('en-GB')
          }],
          vigencia: [{
            startValidity: hoursInicio,
            endValidity: hoursFin,
            hourStart: hoursStartFirstDayInMonth,
            hoursEnd: hoursEndFirstDayInMonth
          }],
          crushedPrograms: this.crushedPrograms,
          userName: this.userName,
          userEmail: this.userEmail,
          signalsCode: this.arrSignalsCode,
          codeDays: this.codigoDias,
          geminisCode: null,
          typeOfContent: this.formProgram.typeOfContent.trim(),
          checkedChanels: this.formProgram.checkedChanels,
          codeTypeContent: this.codeTypeContent,
          userNameAlta: this.userName,
          priceForDay: this.formProgram.priceForDay
        }
        console.log(newProgram, "newProgram")
        await HTTP.post(`programs`, newProgram)
        .then(res => {
          console.log(res.data)
          if (res.data.isEqualSequences) {
            this.nuevocodigoProgram = res.data.newCodeProgram
            this.addProgramModal = true
          }
          else {
            this.isModalSecuences = true
          }
          this.arrCheckCrosses = []
          this.crushedPrograms = []
        })
        .catch(err => {
          console.log(err)
        });

      }
      else {
        let start = formatDateString(this.formProgram.validity[0].startValidity)
        let end = formatDateString(this.formProgram.validity[0].endValidity)
        let validity =  [{
          startValidity: start,
          endValidity: end
        }]

      let hoursStartFirstDayInMonth = this.obteniendoLaPrimeraFechaDelMes(this.formProgram.validity[0].startValidity, this.formProgram.scheduleStartHour, this.formProgram.scheduleStartMin)
      let hoursEndFirstDayInMonth = this.obteniendoLaPrimeraFechaDelMes(this.formProgram.validity[0].startValidity, this.formProgram.scheduleEndHour, this.formProgram.scheduleEndMin)

        console.log(validity, 'validity')
        console.log(this.formProgram, 'this.formProgram')
        console.log('actualizando el programa')

        HTTP.patch('programs/' + this.formProgram._id, [
        { propName: "codeTypeContent", value: this.codeTypeContent },
        { propName: "typeOfContent", value: this.formProgram.typeOfContent.trim() }, 
        { propName: "checkedChanels", value: this.formProgram.checkedChanels }, 
        { propName: "programTitle", value: this.formProgram.programTitle.trim()},
        { propName: "programTitleGeminis", value: this.formProgram.programTitleGeminis.trim()},
        { propName: "programType", value: this.formProgram.programType}, 
        { propName: "transmissionDays", value: this.formProgram.transmissionDays}, 
        { propName: "transmissionDaysDescription", value: this.formProgram.transmissionDaysDescription}, 
        { propName: "checkedSignals", value: this.formProgram.checkedSignals}, 
        { propName: "checkedSignalsDescription", value: this.formProgram.checkedSignalsDescription}, 
        { propName: "scheduleStartHour", value: this.formProgram.scheduleStartHour}, 
        { propName: "scheduleStartMin", value: this.formProgram.scheduleStartMin}, 
        { propName: "scheduleEndHour", value: this.formProgram.scheduleEndHour}, 
        { propName: "scheduleEndMin", value: this.formProgram.scheduleEndMin}, 
        { propName: "validity", value: validity },
        { propName: "userName", value: this.userName},
        { propName: "userEmail", value: this.userEmail},
        { propName: "codProgram", value: this.formProgram.codProgram},
        { propName: "codeDays", value: this.codigoDias},
        { propName: "signalsCode", value: this.arrSignalsCode},
        { propName: "geminisCode", value: this.formProgram.geminisCode},
        { propName: "userNameModi", value: this.userName},
        { propName: "priceForDay", value: this.formProgram.priceForDay},
        { propName: "vigencia", value: [{
          startValidity: hoursInicio,
          endValidity: hoursFin,
          hourStart: hoursStartFirstDayInMonth,
          hoursEnd: hoursEndFirstDayInMonth
        }]}, ])
        .then(res => {
          this.$router.push({name: 'programs'});
        })
        .catch(err => {
          console.log(err)
        })
      }
    },
    updateAllPrice (allGrid, geminisCodeProgram ) {
      
      // let idGrid 
      allGrid.map((allProgram) => {
        
        let idGrid =  allProgram._id
        allProgram.preliminaryPrograms.map((program) => {
          
          if ( Number(program.geminisCodeProgram) == geminisCodeProgram  ) {
            program.chapters.map((chapter) => {
              
              if (chapter.priceByPass) {
                 chapter.priceByPass = this.formProgram.priceForDay
              }
              else {
                this.$set(chapter, "priceByPass", this.formProgram.priceForDay)
              }
            })

          }
          
        })
        //hacer patch 
        HTTP.patch('grid/update/' + idGrid,[
          { propName: "preliminaryPrograms", value: allProgram.preliminaryPrograms },

        ])
      })
      this.patchProgram()
    },
    patchProgram () {
      console.log(this.formProgram, 'this.formProgram')
      HTTP.patch('programs/updateOnlyMongo/' + this.formProgram._id,[
        { propName: "userName", value: this.userName},
        { propName: "userNameModi", value: this.userName},
        { propName: "userEmail", value: this.userEmail},
        { propName: "codProgram", value: this.formProgram.codProgram },
        { propName: "programTitle", value: this.formProgram.programTitle},
        { propName: "priceForDay", value: this.formProgram.priceForDay }
      ])
      .then(res => {
        let dataType = "programs"
        this.$store.dispatch("getData", dataType)
        this.$router.push({name: 'programs'});
      })

    },
    onSubmitProgramMongo () {
      // PATCH SOLO A MONGO
      HTTP.get('grid')
      .then(res => {
        this.updateAllPrice(res.data.grid, Number(this.formProgram.geminisCode) )
      })
      .catch(err => console.log(err))
    },
    onSubmitProgramMongo () {
      
      // PATCH SOLO A MONGO
      let obj = {
        "geminisCode": this.formProgram.geminisCode,
        "priceProgram": this.formProgram.priceForDay 

      }

      HTTP.post(`grid/updatePriceAllGrid`, obj)
      this.patchProgram()


      // HTTP.get('grid')
      // .then(res => {
      //   this.updateAllPrice(res.data.grid, Number(this.formProgram.geminisCode) )
      // })
      // .catch(err => console.log(err))
    },
    handleCheckAllChange (val) {
      this.formProgram.checkedSignals = val ? this.signalsTable : [];
      this.isIndeterminate = false;
      let arrCode = []
      let arrIndexCode = this.arraySignalCode(this.signalsTable)
      for(var r=0; r<arrIndexCode.length; r++){
        arrCode.push(this.signalsByCode[arrIndexCode[r]])
      }
      this.arrSignalsCode = arrCode
    },
    handleCheckedSignalsChange (value) {
      console.log('como')
      let arrCode = []
      let checkedCount = value.length;
      this.checkAll = checkedCount === this.signals.length;

      let arrIndexCode = this.arraySignalCode(value)
      for(var r=0; r<arrIndexCode.length; r++){
        arrCode.push(this.signalsByCode[arrIndexCode[r]])
      }
      this.arrSignalsCode = arrCode
      this.isIndeterminate = checkedCount > 0 && checkedCount < this.signals.length;
      if(this.formProgram.checkedChanels.length == 2) {
        const existNX = Boolean(this.arrSignalsCode.filter((e) => e == "NX").length)
        !existNX ? this.arrSignalsCode.push("NX") : ''
      }
    },
    arraySignalCode (val) {
      let arrayIndex = []
      for(var x=0; x<val.length; x++){
        for(var y=0; y<this.signals.length; y++){
          if(this.signals[y] == val[x]){
            arrayIndex.push(y)
          }
        }
      }
      return arrayIndex
    },
    arrayDiasCode (val) {
      let arrayIndex = []
      for(var x=0; x<val.length; x++){
        for(var y=0; y<this.days.length; y++){
          if(this.days[y] == val[x]){
            arrayIndex.push(y)
          }
        }
      }
      return arrayIndex
    },
    cleanAllInputs (formProgram) {
      this.$refs[formProgram].resetFields()
      this.transmission = [];
      this.formProgram.programTitle = ''
      this.formProgram.checkedSignals = [];
      this.isIndeterminate = true;
      this.arrSignalsCode = []
      // this.getLastCode ()
    },
    viewListPrograms () {
      this.$router.push({name: 'programs'})
    },
    addZero (element) {
      if (element.length === 1) {
        element = "0" + element;
      }
    },
    cleanArrcheckCrosses () {
      this.arrCheckCrosses = []
      this.crushedPrograms = []
    },
    // isTimeEndMayor() {

    // }
  },
  watch: {
    verifyChangeModal(val) {
      if(this.flagComputed>0){
        this.contador = this.contador==-1? this.contador+2:this.contador+1;
      }       
    },'formProgram.programTitle'(oldTitle,newTitle){
      if(oldTitle==undefined) return;
      this.contador = this.contador>0? this.contador+1:-1;
    },'formProgram.scheduleStartHour'(val) {
      this.formProgram.scheduleStartHour = validateTime(val, 23)
    },
    'formProgram.scheduleStartMin'(val) {
      this.formProgram.scheduleStartMin = validateTime(val, 59)
    },
    'formProgram.scheduleEndHour'(val) {
      this.formProgram.scheduleEndHour = validateTime(val, 23)
    },
    'formProgram.scheduleEndMin'(val) {
      this.formProgram.scheduleEndMin = validateTime(val, 59)
    },
    checkAll(val) {
      if(val == false) {
        this.arrSignalsCode = []
      }
    },
    visorMultipleItems(val) {
      // console.log(this.formProgram.checkedSignals, ' this.formProgram.checkedSignals')
      if(this.formProgram.checkedChanels.length == 1) {
        if(this.formProgram.checkedChanels[0] == "América Next") {
          this.channelSelected = false
          this.formProgram.checkedSignals = []
          this.arrSignalsCode = ["NX"]
          this.isBtnDisabled = false
        } else {
          const arrNew = this.arrSignalsCode.filter((e) => e !== "NX")
          this.arrSignalsCode = arrNew
          this.isBtnDisabled = this.arrSignalsCode.length >= 1 ? false : true
        }
      } else if(this.formProgram.checkedChanels.length == 2) {
        this.channelSelected = true
        const existNX = Boolean(this.arrSignalsCode.filter((e) => e == "NX").length)
        !existNX ? this.arrSignalsCode.push("NX") : ''
        this.isBtnDisabled = this.arrSignalsCode.length >= 1 ? false : true
        console.log(val, ' se selecciono 2')
      } else {
        // console.log(this.formProgram.checkedSignals, ' this.formProgram.checkedSignals')
        // console.log(this.arrSignalsCode, 'arrSignalsCode')
        this.channelSelected = true
        this.isBtnDisabled = this.arrSignalsCode.length >= 2 ? false : true
      }
    },
    // visorTime(data) {
    //   this.isTimeEndMayor(data)
    //   // console.log(data, 'visorTime')
    // },
  }
}
</script>

<style>
  .inputTitle > .el-form-item__content{
    width: 75%;
  }
  .selectInput > .el-form-item__content{
    width: 60%;
  }
  .inputTitle > .el-form-item__content, .selectInput > .el-form-item__content, .inputTitleLarge > .el-form-item__content {
    display: inline-block;
  }

  .inputTitle > .el-form-item__label, .selectInput > .el-form-item__label, .inputTitleLarge > .el-form-item__label{
    text-align: left;
    font-size: 16px;
  } 

  .inputTitle > .el-form-item__label, .selectInput  > .el-form-item__label{
    width: 100px;
  }

  .inputTitleLarge > .el-form-item__label{
    width: 200px;
  }

  .el-form-item.inputTitle, .el-form-item.inputTitleLarge{
    margin-bottom: 0;
  }
</style>